import { Module } from 'vuex';
import { defineAsyncComponent } from 'vue';
import mainRoutes from './routes';
import { FG_Plugin } from 'src/plugins';
import { StateInterface } from 'src/store';
import store, { ScheduleInterface } from './store/schedule';

const plugin: FG_Plugin.Plugin = {
  name: 'Schedule',
  mainRoutes,
  requiredModules: ['User'],
  requiredBackendModules: ['schedule'],
  version: '0.0.1',
  store: new Map<string, Module<ScheduleInterface, StateInterface>>([['schedule', store]]),
  widgets: [
    {
      priority: 0,
      name: 'stats',
      permissions: [],
      widget: defineAsyncComponent(() => import('./components/Widget.vue')),
    },
  ],
};

export default plugin;
